#include <WiFi.h>
#include <HTTPClient.h>

const char* ssid = "I_Am_Blessed";
const char* password = "Innovate!";

#include <Wire.h> []
#include <LiquidCrystal_I2C.h>

LiquidCrystal_I2C lcd(0x27,20,4);
// set pin numbers

const int Button1 = 15;
const int led = 26; 
const int Button2 = 2; 
const int Button3 = 4; 
const int Button4 = 17; 
const int Button5 = 16;
int buttonstate=0, prev=0;


String ServerName="192.168.137.191";


int Q1_response=0,Q2_response=0,Q3_response=0, common_value=0, stage=0;

void setup(){
  Serial.begin(115200);
 lcd.init();
  lcd.backlight();

  pinMode(led,OUTPUT);
  pinMode(Button1,INPUT_PULLUP);
  pinMode(Button2,INPUT_PULLUP);
  pinMode(Button3,INPUT_PULLUP);
  pinMode(Button4,INPUT_PULLUP);
  pinMode(Button5,INPUT_PULLUP);
  WiFi.begin(ssid, password);
  Serial.println("Connecting");
  while(WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
    wifi_msg();
  }
  Serial.println("");
  Serial.print("Connected to WiFi network with IP Address: ");
  digitalWrite(led,HIGH);
 Serial.println(WiFi.localIP());
 wifi_connected();
 delay(2000);
  Serial.println("Timer set to 5 seconds (timerDelay variable), it will take 5 seconds before publishing the first reading.");
}

void loop(){
  
  if(stage==0){
    q1_screen();
  }
  delay(500);
}


  ////////////////////////////////////////////////////////////////////////////////////
      /*        getting response               */
  ///////////////////////////////////////////////////////////////////////////////////////
int Responses()
{
  int waiting=0;
  while(waiting ==0){
    if(digitalRead(Button1)== LOW || digitalRead(Button2) == LOW|| digitalRead(Button3)== LOW || digitalRead(Button4)== LOW ||digitalRead(Button5)== LOW){
    
    buttonstate=1;
   
  }
  else{buttonstate=0;
  prev=0;}
 if (digitalRead(Button1) == LOW && buttonstate==1 && prev==0 ){
  Serial.println("Excellent Button pressed");
  common_value=100;
  waiting=1;
  prev=1;
 }
  if (digitalRead(Button2) == LOW && buttonstate==1 && prev==0   ){
  Serial.println("very good Button pressed");
  common_value=75;
  waiting=1;
  prev=1;
 }

  if (digitalRead(Button3) == LOW  && buttonstate==1 && prev==0 ){
   Serial.println("Good Button pressed");
   common_value=50;
   waiting=1;
   prev=1;
 }
   if (digitalRead(Button4) == LOW  && buttonstate==1 && prev==0 ){
 Serial.println("Bad Button pressed");
  common_value=25;
  waiting=1;
  prev=1;
 }
  

 if (digitalRead(Button5) == LOW && buttonstate==1 && prev==0 ){
   Serial.println("Very Bad Button pressed");
   common_value=0;
   waiting=1;
  prev=1;
 }
}
return common_value;
}





  ////////////////////////////////////////////////////////////////////////////////////
      /*        Asking questions              */
  ///////////////////////////////////////////////////////////////////////////////////////




  ////////////////////////////////////////////////////////////////////////////////////
      /*         sending feedback               */
  ///////////////////////////////////////////////////////////////////////////////////////


void sendFeedback(String Q1,String Q2,String Q3) {
  sending_screen();
  Serial.println(Q1+"  "+Q2+"  "+Q3);


//Check WiFi connection status
    if(WiFi.status()== WL_CONNECTED){
      HTTPClient http;

      String serverPath = "http://"+ServerName+"/eric/insert.php?Q1="+Q1+"&Q2="+Q2+"&Q3="+Q3;
      
      // Your Domain name with URL path or IP address with path
      http.begin(serverPath.c_str());
      
      // If you need Node-RED/server authentication, insert user and password below
      //http.setAuthorization("REPLACE_WITH_SERVER_USERNAME", "REPLACE_WITH_SERVER_PASSWORD");
      
      // Send HTTP GET request
      int httpResponseCode = http.GET();
      
      if (httpResponseCode>0) {
        Serial.print("HTTP Response code: ");
        Serial.println(httpResponseCode);
        String payload = http.getString();
        Serial.println(payload);
        digitalWrite(led,LOW);
        delay(300);
        digitalWrite(led,HIGH);
        delay(300);
        digitalWrite(led,LOW);
        delay(300);
        digitalWrite(led,HIGH);
        delay(300);
         //check for success server response
  if(httpResponseCode == -1){
  lcd.clear();
  lcd.setCursor(2, 1);
  lcd.print("DATA RECORDED");
  lcd.setCursor(2, 2);
  lcd.print("THANK YOU ");
        }         
  delay(3000);
        stage=0;
        loop();
      }
      else {
        Serial.print("Error code: ");
        Serial.println(httpResponseCode);
        if(httpResponseCode == -1){
  lcd.clear();
  lcd.setCursor(2, 1);
  lcd.print("server error");
  lcd.setCursor(2, 2);
  lcd.print("Try again later.. ");
        }
        delay(3000);
        loop();
      }
      delay(500);
      // Free resources
      http.end();
    }
    else {
      Serial.println("WiFi Disconnected");
     //error
  lcd.clear();
  lcd.setCursor(2, 1);
  lcd.print("wifi");
  lcd.setCursor(2, 2);
  lcd.print("Disconnected");
   delay(3000);

    }
        stage=0;
    }




void q1_screen(){
  lcd.clear();
  lcd.setCursor(0, 0);
  lcd.print("How was Friendly and");
  lcd.setCursor(0, 1);
  lcd.print("helpful attitude of");
  lcd.setCursor(0, 2);
  lcd.print("Staff?");
  Serial.print("");
  Serial.print("How was Friendly and helpful attitude of Staff?");
  Q1_response=Responses();
  delay(1000);
  q2_screen();
  stage=1;
 }
void q2_screen() {
  lcd.clear();
  lcd.setCursor(0, 0);
  lcd.print("How was Quality of");
  lcd.setCursor(0, 1);
  lcd.print("received service ?");
  Serial.println("");
  Serial.print("How was Quality of received service ?");
  Q2_response=Responses();
  delay(1000);
  q3_screen();
 }
void q3_screen()  {
  lcd.clear();
  lcd.setCursor(0, 0);
  lcd.print("How was Timeliness");
  lcd.setCursor(0, 1);
  lcd.print("of the service");
  lcd.setCursor(0, 2);
  lcd.print("delivery?");
  Serial.println("");
  Serial.print("How was Timeliness of the service delivery?");
  Q3_response=Responses();
  delay(1000);
  sending_screen();
  sendFeedback(String(Q1_response),String(Q2_response),String(Q3_response));
  stage=0;
  Q1_response=0;
  Q2_response=0;
  Q3_response=0;
  }
void sending_screen(){
  lcd.clear();
  lcd.setCursor(2, 1);
  lcd.print("THANK YOU FOR");
   lcd.setCursor(2, 2);
  lcd.print("YOUR FEEDBACK");
  
}
void wifi_msg(){
  lcd.clear();
  lcd.setCursor(2, 1);
  lcd.print("CONNECTING ");
  lcd.setCursor(2, 2);
  lcd.print("TO WIFI..");

}
void wifi_connected(){
  lcd.clear();
  lcd.setCursor(2, 1);
  lcd.print("WIFI");
  lcd.setCursor(2, 2);
  lcd.print("CONNECTED");

}